<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Login extends CI_Controller {

	/**
	 * Index Page for this controller.
	 *
	 * Maps to the following URL
	 * 		http://example.com/index.php/welcome
	 *	- or -
	 * 		http://example.com/index.php/welcome/index
	 *	- or -
	 * Since this controller is set as the default controller in
	 * config/routes.php, it's displayed at http://example.com/
	 *
	 * So any other public methods not prefixed with an underscore will
	 * map to /index.php/welcome/<method_name>
	 * @see https://codeigniter.com/userguide3/general/urls.html
	 */
	
	public function index()
	{
		$this->load->model('loginmodel');
		$this->load->helper('form');
		//$this->load->view('includes/header');
		$this->load->view('login');
		//$this->load->view('includes/footer');
	}
	
	public function forgot_password()
	{
		$this->load->model('loginmodel');
		$this->load->helper('form');
		//$this->load->view('includes/header');
		$this->load->view('forgot_password');
		//$this->load->view('includes/footer');
	}
	public function get_otp_for_admin()
	{
	    $this->load->model('mainmodel');
	    $admin_mobile = $this->input->post('admin_mobile');
	    $get_admin_mobile = $this->mainmodel->common_fetch('admin',array('id' => 1));
	    
	    if(!empty($get_admin_mobile)){
	        if($get_admin_mobile[0]->admin_mobie == $admin_mobile){
	            $mobile = $get_admin_mobile[0]->admin_mobie;
	            $otp = rand(1000,9999);
	            $this->send_otp_sms_post($mobile,$otp);
	            $json_data = array(
	                 "status" => true,
	                  "message" => "Otp sent to mobile number",
	                  "otp" => $otp
            );
	        }else{
	            $json_data = array(
	                 "status" => false,
	                  "message" => "Wrong Mobile Number",
	                  "otp" => ""
            );
	        }
	    }
	    
             echo json_encode($json_data);exit; 
             
             
	}
	
	public function change_password()
	{
	    $this->load->model('mainmodel');
	    $real_otp = $this->input->post('real_otp');
	    $main_otp = $this->input->post('main_otp');
	    $password = $this->input->post('password');
	    $confirm_password = $this->input->post('confirm_password');
	    if($real_otp == $main_otp){
	        if(empty($password) || empty($confirm_password)){
	            $json_data = array(
	                 "status" => false,
	                  "message" => "password and confirm password are empty"
            );
	        }else{
	             if($password == $confirm_password){
        	            $data = array(
        	            'password' => md5($password),
        	            'updated_on' => date('Y-m-d H:i:s')
        	            );
        	            $update = $this->mainmodel->common_update('admin',$data,array('id' => 1));
        	            $json_data = array(
        	                 "status" => true,
        	                  "message" => "New password updated"
                    );
        	        }else{
        	            $json_data = array(
        	                 "status" => false,
        	                  "message" => "password and confirm password are missmatch"
                    );
        	        }
	        }
	       
	    }else{
	        $json_data = array(
	                 "status" => false,
	                  "message" => "Wrong OTP"
            );
	    }
	    
	    echo json_encode($json_data);exit; 
	}
	
	public function checklogin()
	{
		$this->load->model('loginmodel');
		$this->load->helper('form');

// 		$this->form_validation->set_rules('username', 'Username', 'required');
// 		$this->form_validation->set_rules('password', 'Password', 'required|callback_verifyuser');
		
// 		if($this->form_validation->run() == false){
// 			$data['title'] = "Ayur";
// 			//$this->load->view('includes/header', $data);
// 			$this->load->view('login', $data);
// 			//$this->load->view('includes/footer', $data);
// 		}else{
// 			redirect('welcome/index');
// 		}
  //  if(isset($this->input->post('username')) && isset($this->input->post('password'))){
				
	    $username = $this->input->post('username');
		$password = $this->input->post('password');
		//echo "<pre>";
		//echo $username;
//exit;
		$this->load->model('loginmodel');
		$this->load->helper('form');
		$row = $this->loginmodel->login($username, $password);
		$row1 = $this->loginmodel->school_admins($username, $password);
		//var_dump($row);exit;
// 		echo "<pre>";
// 		echo $username;
// 		echo $this->db->last_query();
// 		print_r($row1);exit;
		if(!empty($row)){
		   
		  if($row->status == "1" && $row->delete_status == 1){
			$this->session->set_userdata(array(
				'admin_id'  => $row->id,
				'is_logged_in' => TRUE,
				'role' => $row->user_type,
				'school_id' => ''
				
			  ));
			  $json_data = array(
				  'status' => true,
				  'message' => "welcome to your dashboard.",
				  'role' => $row->user_type
			  );
			  echo json_encode($json_data);

		  }
		  //else if($row->status == "0" && $row->delete_status == 1){
			 // $json_data = array(
				//   'status' => false,
				//   'message' => "Your account is inactive.please contact super admin"
			 // );
			 // echo json_encode($json_data);
		  //}
		  else{
			  $json_data = array(
				'status' => false,
				'message' => "Invalid credentials",
				'role' => ''

			  );
			  echo json_encode($json_data);
		  }
		        //$get_permissions = $this->loginmodel->common_fetch('admin_permissions',array('role_id' => $row->role_id));
		        	
		    
		  //  echo "<pre>";print_r($_SESSION);exit;
		
	//	redirect('welcome/index');
		}
		else if(!empty($row1))
		{
		    if($row1->status == "1" && $row1->delete_status == 1){
			$this->session->set_userdata(array(
				'admin_id'  => $row1->id,
				'is_logged_in' => TRUE,
				'role' => $row1->user_type,
				'school_id' => $row1->school_id
				
			  ));
			  $json_data = array(
				  'status' => true,
				  'message' => "welcome to your dashboard.",
				  'role' => $row1->user_type
			  );
			  echo json_encode($json_data);

		  }else if($row1->status == "0" && $row1->delete_status == 1){
			  $json_data = array(
				  'status' => false,
				  'message' => "Your account is inactive.please contact super admin",
				  'role' => ''
			  );
			  echo json_encode($json_data);
		  }else{
			  $json_data = array(
				'status' => false,
				'message' => "Invalid credentials",
				'role' => ''

			  );
			  echo json_encode($json_data);
		  }
		        
		    
		}
		else{
		// 	$this->form_validation->set_message('verifyuser', 'Username or Password is Incorrect. Please try again');
		// //	$this->load->view('login', $data);
		// $this->session->set_flashdata('success-error', 'Username or Password is Incorrect. Please try again.');
		// 	redirect('login');
		$json_data = array(
			'status' => false,
			'message' => "Invalid credentials"

		  );
		  echo json_encode($json_data);
		}

		exit;

	}
public function verifyuser()
	{
// 		$username = $this->security->xss_clean($this->input->post('username'));
// 		$password = $this->security->xss_clean($this->input->post('password'));
		$username = $this->input->post('username');
		$password = $this->input->post('password');
		
		$this->load->model('loginmodel');
		$this->load->helper('form');
		$row = $this->loginmodel->login($username, $password);
		//var_dump($row);exit;
		//echo "<pre>";print_r($row);exit;
		if(!empty($row)){
		    if(($row->role_id != 0) && $row->role_id > 0){
		        $get_role = $this->loginmodel->get_roles($row->role_id);
		        //$get_permissions = $this->loginmodel->common_fetch('admin_permissions',array('role_id' => $row->role_id));
		        	$this->session->set_userdata(array(
							'admin_id'  => $row->id,
                            'is_logged_in' => TRUE,
                            'role' => $get_role[0]->role_name,
                            'permissions' => $get_role[0]->roel_permission
                            
                    ));
		    }else{
		        	$this->session->set_userdata(array(
							'admin_id'  => $row->id,
                            'is_logged_in' => TRUE,
                            'role' => 'admin',
                            'permissions' => 'all'
                    ));
		    }
		    
	//	    echo "<pre>";print_r($_SESSION);exit;
		
			return true;
		}else{
			$this->form_validation->set_message('verifyuser', 'Username or Password is Incorrect. Please try again');
			return false;
		}
	}
	
	
	function send_otp_sms_post($mobile,$otp)
    {
        $data=array("otp"=>$otp);
      //  $this->mainmodel->common_insert("msg_track",$data);
        $message="Your OTP to Login into your Jolly District is $otp. Do not share OTP with others for security reasons. Thankyou";
        //echo 'http://sms.hspsms.com/sendSMS?username=eeggshop&message='.$message.'&sendername=EGGSHP&smstype=TRANS&numbers='.$mobile.'&apikey=60ac02e8-df28-40be-9a4d-92c77a40beb2';
      //  http://sms.hspsms.com/sendSMS?username=eeggshop&message=%27.$otp.%27%20is%20the%20login%20OTP%20for%20eEgg%20Shop%20verification.%20Thankyou&sendername=SLNEGG&smstype=TRANS&numbers=%27.$mobile.%27&apikey=380a4d4b-e39b-45d7-9416-15c04e90bf60
        // create a new cURL resource
        $ch = curl_init();	
        
        // set URL and other appropriate options
        //curl_setopt($ch, CURLOPT_URL, 'http://sms.hspsms.com/sendSMS?username=eeggshop&message='.$otp.'%20is%20the%20OTP%20for%20eEgg%20Shop%20verification.%20Thankyou&sendername=EGGSHP&smstype=TRANS&numbers='.$mobile.'&apikey=60ac02e8-df28-40be-9a4d-92c77a40beb2');
        //curl_setopt($ch, CURLOPT_URL, 'http://sms.hspsms.com/sendSMS?username=eeggshop&message='.$otp.'%20is%20the%20login%20OTP%20for%20eEgg%20Shop%20verification.%20Thankyou&sendername=SLNEGG&smstype=TRANS&numbers='.$mobile.'&apikey=380a4d4b-e39b-45d7-9416-15c04e90bf60');
        curl_setopt($ch, CURLOPT_URL,'http://sms.hspsms.com/sendSMS?username=jollydistrict&message=Your%20OTP%20to%20Login%20into%20your%20Jolly%20District%20is%20'.$otp.'.%20Do%20not%20share%20OTP%20with%20others%20for%20security%20reasons.%20Thankyou&sendername=JLYDST&smstype=TRANS&numbers='.$mobile.'&apikey=9622b6fa-5f61-4f89-b6f5-dc1bf295ac53');
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        // grab URL and pass it to the browser
         $response = curl_exec($ch);
        //echo $d;
        // close cURL resource, and free up system resources
        //print_r($response);exit;
        curl_close($ch);
        return true;
       // http://sms.hspsms.com/sendSMS?username=jollydistrict&message=Your OTP to Login into your Jolly District is 1234. Do not share OTP with others for security reasons. Thankyou&sendername=XYZ&smstype=TRANS&numbers=9059586793&apikey=9622b6fa-5f61-4f89-b6f5-dc1bf295ac53
    }
}
