<main id="main" class="main">
      <div class="messagelisting py-3 px-4">
        <div class="pagetitle m-0">
          <h1>School Fee Components</h1>
          <nav>
            <ol class="breadcrumb m-0">
              <li class="breadcrumb-item"><a href="<?=base_url()?>schooldashboard">Home</a></li>
              <li class="breadcrumb-item">Fees</li>
              <li class="breadcrumb-item text-dark">Fee Components</li>
            </ol>
          </nav>
        </div>

        <div class="dropdown">
          <button class="dropbtn">
            <span class="text-dark">Today</span> <?=date('D, d M')?>
          </button>
        </div>
      </div>

      <section class="section">
        <div class="row justify-content-center align-items-center">
          <div class="col-lg-12">
           <form class="row g-3" method="post"  id="schoolForm" enctype="multipart/form-data">
              <div class="card px-3 py-3">
                <div class="Accountdetails pt-2 px-3">
                  <div class="">
                    <h6 class="fw-bolder">Create Fee Component</h6>
                  </div>
                </div>
                <div class="card-body">
                  <div class="row g-3 needs-validation" novalidate="">
                    <div class="col-md-5">
                      <label for="validationCustom02" class="form-label"
                        >Name <span class="text-danger"> *</span>
                      </label>
                      <input
                        type="text" name="component_name" id="component_name"
                        class="form-control"
                        placeholder="Name" required
                      />
                      
                    </div>

                    <div class="col-md-5">
                      <label for="validationCustom02" class="form-label"
                        >Periodicity <span class="text-danger">*</span>
                      </label>
                      <select  class="form-select" name="time_period" id="time_period" required>
                        <option value="">Choose...</option>
                        <option value="Monthly">Monthly</option>
                        <option value="One Time">One Time</option>
                        <option value="Yearly">Yearly</option>
                      </select>
                    </div>

                    <div class="col-md-2 pt-3">
                      <label for="validationCustom02" class="form-label">
                        <span class="text-danger"></span
                      ></label>
                      <button class="btn btn-danger mt-4" id="createdata" type="button">
                        <i class="bi bi-check"></i> &nbsp; Create
                      </button>
                    </div>
                  </div>
                </div>
              </div>
 </form>
              <section class="section contact">
                <div class="row gy-4">
                  <div class="col-xl-12">
                    <div class="row">
                   <?php foreach($getdetails as $row){ ?>     
                      <div class="col-lg-6">
                        <div class="info-box card">
                          <div class="">
                            <a
                              href="#" type="button"
                              onclick="open_model_update(<?= $row->id?>)"
                            >
                              <i class="bi bi-pencil-square"></i
                            ></a>
                            <a href="#" onclick="delete_fee_componenet(<?= $row->id?>)"> <i class="bi bi-archive"></i></a>
                          </div>
                          <div class>
                            <h3><?= $row->component_name?></h3>
                            <p>Periodicity:<?= $row->time_period?></p>
                          </div>
                        </div>
                      </div>
                      <?php } ?>
                      

                      <!--Update School fee  Modal -->
                      <div
                        class="modal fade"
                        id="exampleModal"
                        tabindex="-1"
                        aria-labelledby="exampleModalLabel"
                        aria-hidden="true"
                      >
                        <div class="modal-dialog">
                          <div class="modal-content">
                            <div class="modal-header">
                              <h5 class="modal-title" id="exampleModalLabel">
                                Update School Fee Component
                              </h5>
                              <button
                                type="button"
                                class="btn-close"
                                data-bs-dismiss="modal"
                                aria-label="Close"
                              ></button>
                            </div>
                            <div class="modal-body">
                              
                                  <form class="row g-3" method="post"  id="save_update" enctype="multipart/form-data">
                                <div class="row">
                                  <div class="col-lg-6">
                                    <div class="mb-3">
                                      <label
                                        for="exampleInputEmail1"
                                        class="form-label"
                                        >Name
                                        <span class="text-danger">
                                          *</span
                                        ></label
                                      >
                                      <input
                                        type="text" name="component_name_u" id="component_name_u"
                                        class="form-control"
                                        value="Activity Charges" required
                                      />
                                       <input
                                        type="hidden" name="fee_component_id" id="fee_component_id"
                                        class="form-control" required value=""
                                        
                                      />
                                    </div>
                                  </div>
                                  <div class="col-lg-6">
                                    <div class="mb-3">
                                      <label
                                        for="exampleInputEmail1"
                                        class="form-label"
                                        >Periodicity
                                        <span class="text-danger">
                                          *</span
                                        ></label
                                      >
                                      <select name="time_period_u" id="time_period_u" class="form-select" required>
                                        <option value="">Choose..</option>
                                        <option value="Monthly">Monthly</option>
                                        <option value="Yearly">Yearly</option>
                                        <option value="One Time">One Time</option>
                                      </select>
                                    </div>
                                  </div>


                                  <div class="col-lg-6">
                                    <div class="mb-3">
                                      <label
                                        for="exampleInputEmail1"
                                        class="form-label"
                                        >Include Month
                                        <span class="text-danger">
                                          *</span
                                        ></label
                                      >
                                      <select name="include_month" id="include_month" class="form-select" required>
                                        <option value="">Choose..</option>
                                        <option value="June">June</option>
                                        <option value="July">July</option>
                                        <option value="August">August</option>
                                        <option value="September">September</option>
                                        <option value="October">October</option>
                                        <option value="November">November</option>
                                        <option value="December">December</option>
                                        <option value="January">January</option>
                                        <option value="February">February</option>
                                        <option value="March">March</option>
                                        <option value="April">April</option>
                                        <option value="May">May</option>
                                      </select>
                                    </div>
                                  </div>

                                  <div class="col-lg-6">
                                    <div class="mb-3">
                                      <label
                                        for="exampleInputEmail1"
                                        class="form-label"
                                        >Bank Account
                                        <span class="text-danger">
                                          *</span
                                        ></label
                                      >
                                      <select name="bank_account" id="bank_account" class="form-select" >
                                        <option value="">Choose..</option>
                                      </select>
                                    </div>
                                  </div>

                                  <div class="col-lg-3 d-flex pb-3">
                                    <label for="">Reset<span class="text-danger">*</span></label> &nbsp;
                                    <input type="checkbox" class="form-check">
                                  </div>
                                </div>

                                <button type="button" id="updatedata" class="btn btn-primary">
                                  Update
                                </button>
                              </form>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </section>
           
          </div>
        </div>
      </section>

      <style>
        .info-box.card {
          display: flex !important;
        }

        .bi-pencil-square {
          background-color: #0d1b9b;
          color: #fff;
        }

        .bi-archive {
          background-color: rgb(219, 0, 0);
        }

        .contact .info-box i {
          font-size: 20px;
          line-height: 0;
          color: #ffffff;
          border: 1px solid;
          padding: 5px 10px;
          border-radius: 50px;
        }

        .showdetails {
          min-height: 30vh;
          border-radius: 8px;
          overflow-y: scroll;
          box-shadow: rgba(0, 0, 0, 0.24) 0px 3px 8px;
        }

        .actions img {
          box-shadow: rgba(0, 0, 0, 0.24) 0px 3px 8px;
          border-radius: 50%;
          width: 25px;
          padding: 5px;
        }

        small {
          font-size: 13px;
          color: #626262;
        }

        table {
          width: 100%;
          border-collapse: collapse;
          /* margin: 20px 0; */
          /* font-size: 16px; */
          text-align: left;
        }

        th,
        td {
          padding: 10px 20px;
          font-size: 14px;
        }

        th {
          background-color: #1e4284 !important;
          color: #fff !important;
        }

        .actions {
          text-align: center;
        }

        .buttons {
          padding-top: 1.5rem;
          display: flex;
          justify-content: end;
          gap: 10px;
        }

        .buttons .btn-primary,
        .btn-danger .btn-danger {
          padding: 10px;
          width: 70px !important;
        }

        select,
        option {
          font-size: 14px !important;
        }

        input[type="checkbox"] {
          accent-color: rgb(242, 4, 4);
          border: 1px solid rgb(251, 7, 7);
          width: 15px;
        }
      </style>
    </main>
    <!-- End #main -->
     <script src="https://code.jquery.com/jquery-3.7.1.min.js" crossorigin="anonymous"></script>
  <script>
$(document).ready(function () {
    $('#createdata').on('click', function () {
        let isValid = true;
        
        //alert('hi');
        
        
        // Validate required fields
        $('#schoolForm [required]').each(function () {
            let value = $(this).val(); // Get the value
            if (Array.isArray(value)) {
                value = value.join(''); // Convert array to string
            }
            value = value ? value.toString().trim() : ''; // Convert value to string and trim

            if (value === '') {
                isValid = false;
                $(this).addClass('is-invalid'); // Add error styling
                //alert('hi');
               //showToast('Error', ${$(this).attr('placeholder')} is required, 'error');
               showToast('Error', `${$(this).attr('placeholder')} is required`, 'error');
               //showToast('Error', 'please fill required fields', 'error');
            } else {
                $(this).removeClass('is-invalid'); // Remove error styling
                $(this).addClass('is-valid'); // Mark as valid
            }
        });
        
           // Check section separately, because it's a select element
        const section = $('select[name="time_period"]');
        var usernsmam = section.val();
        if (usernsmam == '') {
            isValid = false;
            section.addClass('is-invalid'); // Add error styling for section
            showToast('Error', 'Please select Periodicity', 'error');
        } else {
            section.removeClass('is-invalid'); // Remove error styling
            section.addClass('is-valid'); // Mark as valid
        }
        

        if (isValid) {
            // If all fields are valid, submit the form

            const form = $('#schoolForm')[0];
            const formData = new FormData(form);

            $.ajax({
                url: '<?= base_url("register/add_fee_components_details"); ?>', // Your endpoint
                type: 'POST',
                data: formData,
                contentType: false,
                processData: false,
                success: function (response) {
                    const res = JSON.parse(response);
                   // alert(res.message);
                    if (res.status) {
                        showToast('Success', res.message, 'success');
                        $('#schoolForm')[0].reset(); // Reset the form
                        $('.form-control').removeClass('is-valid'); // Clear valid states
                        location.reload();
                    } else {
                        showToast('Error', res.message, 'error');
                    }
                },
                error: function () {
                    showToast('Error', 'An unexpected error occurred.', 'error');
                },
            });
        } else {
            // Scroll to the first invalid field
            $('html, body').animate({
                scrollTop: $('.is-invalid:first').offset().top - 100,
            }, 500);
        }
    });

    // Remove validation feedback on input
    $('#schoolForm .form-control').on('input change', function () {
        if ($(this).val().trim() !== '') {
            $(this).removeClass('is-invalid').addClass('is-valid');
        } else {
            $(this).removeClass('is-valid').addClass('is-invalid');
        }
    });
    
     $('#updatedata').on('click', function () {
         
        // $('#save_update')[0].reset();
        let isValid = true;
        
        //alert('hi');
        
        
        // Validate required fields
        $('#save_update [required]').each(function () {
            let value = $(this).val(); // Get the value
            if (Array.isArray(value)) {
                value = value.join(''); // Convert array to string
            }
            value = value ? value.toString().trim() : ''; // Convert value to string and trim

            if (value === '') {
                isValid = false;
                $(this).addClass('is-invalid'); // Add error styling
                //alert('hi');
               //showToast('Error', ${$(this).attr('placeholder')} is required, 'error');
               showToast('Error', `${$(this).attr('placeholder')} is required`, 'error');
               //showToast('Error', 'please fill required fields', 'error');
            } else {
                $(this).removeClass('is-invalid'); // Remove error styling
                $(this).addClass('is-valid'); // Mark as valid
            }
        });
        
            // Check section separately, because it's a select element
        const section = $('select[name="time_period_u"]');
        var usernsmam = section.val();
        if (usernsmam == '') {
            isValid = false;
            section.addClass('is-invalid'); // Add error styling for section
            showToast('Error', 'Please select Periodicity', 'error');
        } else {
            section.removeClass('is-invalid'); // Remove error styling
            section.addClass('is-valid'); // Mark as valid
        }
        
            // Check section separately, because it's a select element
        const section1 = $('select[name="include_month"]');
        var usernsmam = section1.val();
        if (usernsmam == '') {
            isValid = false;
            section1.addClass('is-invalid'); // Add error styling for section
            showToast('Error', 'Please select month', 'error');
        } else {
            section1.removeClass('is-invalid'); // Remove error styling
            section1.addClass('is-valid'); // Mark as valid
        }
        
       
        
      
   

        if (isValid) {
            // If all fields are valid, submit the form

            const form = $('#save_update')[0];
            const formData = new FormData(form);

            $.ajax({
                url: '<?= base_url("register/update_fee_component_details"); ?>', // Your endpoint
                type: 'POST',
                data: formData,
                contentType: false,
                processData: false,
                success: function (response) {
                    const res = JSON.parse(response);
                   // alert(res.message);
                    if (res.status) {
                         $('#exampleModal').modal('hide');
                        showToast('Success', res.message, 'success');
                        $('#save_update')[0].reset(); // Reset the form
                        //$('#generate_id').prop('disabled', false);
                        $('.form-control').removeClass('is-valid'); // Clear valid states
                    } else {
                        showToast('Error', res.message, 'error');
                    }
                },
                error: function () {
                    showToast('Error', 'An unexpected error occurred.', 'error');
                },
            });
        } else {
            // Scroll to the first invalid field
            $('html, body').animate({
                scrollTop: $('.is-invalid:first').offset().top - 100,
            }, 500);
        }
    });
});

function open_model_update(id)
{
 //alert(id);
    $('#save_update')[0].reset(); // Reset the form
     $.ajax({
                url: '<?= base_url("register/get_fee_component_details"); ?>', // Your endpoint
                type: 'POST',
                data: {id},
              //   dataType: "text",
             //   contentType: false,
             //   processData: false,
                success: function (response) {
                    //$("#time_period_u").html("");
                    $("#time_period_u option").each(function() {
  $(this).siblings('[value="'+ this.value +'"]').remove();
});
                    const res = JSON.parse(response);
                    
                   // alert(res.message);
                    if (res.status) {
                         $('#exampleModal').modal('show');
                     //   showToast('Success', res.message, 'success');
                        //$('#update_form')[0].reset(); // Reset the form
                        $('.form-control').removeClass('is-valid'); // Clear valid states
                         // Create a new option element
                const newOption = $('<option>', {
                    value: res.details[0]['time_period'],
                    text: res.details[0]['time_period'],
                    selected: true
                });
                 $('#fee_component_id').val();
                // Append the new option to the select
                $('#time_period_u').append(newOption);
                $('#component_name_u').val(res.details[0]['component_name']);
                $('#fee_component_id').val(res.details[0]['id']);
                
                
                       // location.reload();
                    } else {
                        showToast('Error', res.message, 'error');
                    }
                },
                error: function () {
                    showToast('Error', 'An unexpected error occurred.', 'error');
                },
            });

}
function delete_fee_componenet(id)
{
    if (confirm('Are you sure you want to delete this Component?')) {
   // alert('Component deleted');
     $.ajax({
                url: '<?= base_url("register/delete_fee_component_details"); ?>', // Your endpoint
                type: 'POST',
                data: {id},
              //   dataType: "text",
             //   contentType: false,
             //   processData: false,
                success: function (response) {
                    const res = JSON.parse(response);
                    
                   // alert(res.message);
                    if (res.status) {
                       
                        showToast('Success', res.message, 'success');
                       location.reload();
                    } else {
                        showToast('Error', res.message, 'error');
                    }
                },
                error: function () {
                    showToast('Error', 'An unexpected error occurred.', 'error');
                },
            });
} else {
   // alert('Component not deleted');
}
}

</script>