<!--<link href="https://cdn.datatables.net/2.1.8/css/dataTables.dataTables.min.css" rel="stylesheet">-->
<main id="main" class="main">
        <div class="messagelisting py-3 px-4">
            <div class="pagetitle m-0">
                <h1> Gate Pass Listing</h1>
                <!--<nav>-->
                <!--    <ol class="breadcrumb m-0">-->
                <!--        <li class="breadcrumb-item"><a href="index.html">Home</a></li>-->
                <!--        <li class="breadcrumb-item">Staff </li>-->
                <!--        <li class="breadcrumb-item text-dark ">Edit Staff</li>-->
                <!--    </ol>-->
                <!--</nav>-->
            </div>

            <div class="dropdown">
               <button class="dropbtn"><span class="text-dark">Today </span> <?=date('D, d M')?></button>
            </div>
        </div>

        <section class="section">
            <div class="row justify-content-center align-items-center">
                <div class="col-lg-12">
                    <div class="col-lg-12">
                    <form action="">
                        <div class="card px-3 py-3">
                             
                            <div class="card-body">
                                <div class="row g-3 needs-validation" novalidate="">
                                   <div class="addbook d-flex justify-content-between align-items-center">
                                <h5 class="px-3 py-3"> Search Expense </h5>
                                <a href="<?=base_url('add-expense')?>" class="btn btn-danger" >Add Expense </a>
                            </div>
                                   <div class="col-md-4 ">
                                        <label for="" class="form-label">Vendor</label>
                                        <select name="vendor" class="form-select" id="vendor">
                                            <option value="">Select Vendor</option>
                                             <?php foreach($vendors as $vendor){ ?>
                                            <option value="<?= $vendor->id?>"><?= $vendor->company_name?></option>
                                            <?php } ?>
                                        </select>
                                    </div>
                                    <div class="col-md-4 ">
                                        <label for="" class="form-label">Category</label>
                                        <select name="category" class="form-select" id="category">
                                            <option value="">Select Category</option>
                                            <option value="Petty">Petty </option>
                                            <option value="Meal">Meal </option>
                                            <option value="House Keeping">House Keeping </option>
                                            <option value="Conveyance">Conveyance </option>
                                        </select>
                                    </div>

                                    <div class="col-md-4 ">
                                        <label for="" class="form-label">Status</label>
                                        <select name="status" class="form-select" id="status">
                                            <option value="">Select </option>
                                            <option value="Pending Approval">Pending Approval</option>
                                            <option value="Approved">Approved</option>
                                            <option value="Paid">Paid</option>
                                            <option value="Partial Paid">Partial Paid</option>
                                            <option value="Cancelled">Cancelled</option>
                                        </select>
                                    </div>
                                    <div class="col-md-4">
                                     <label for="" class="form-label">Purchase From Date </label>
                                        <input type="date" class="form-control" placeholder="Name"  name="from_date" id="from_date">
                                    </div>
                                    <div class="col-md-4">
                                     <label for="" class="form-label">Purchase To Date </label>
                                        <input type="date" class="form-control" placeholder="Name"  name="to_date" id="to_date">
                                    </div>
                                  
                                   
                                    
                                    <div class="col-md-3 pt-1">
                                        <label for="validationCustom02" class="form-label"> <span
                                                class="text-danger"></span></label>
                                        <button class="btn btn-danger mt-4" id="search_user" type="button">  &nbsp;Search</button>
                                        
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                     </form>

                        <div class="card px-3 py-3">

                            <div class="card-body">


                                <table id="categories">

                                </table>

                            </div>
                        </div>
                </div>
                   
                </div>
            </div>
        </section>

         <style>
                .submit{
                   margin-right: 1rem;
                    float: right;
                }
                tr {

                    border-bottom: 1px solid rgba(0, 0, 0, 0.3);
                }

                td img{
                    width: 100px;
                }
                table {
                    width: 100%;
                    border-collapse: collapse;
                    margin: 20px 0;
                }

                th,
                td {
                    text-align: left;
                    line-height: 1.8;
                    /* border: 1px solid #ddd; */
                    padding: 8px;
                    font-size: 13px;
                }
                p,.fs-6{
                    font-size: 13px!important;
                }

                th {
                    background-color: #f4f4f4;
                    font-weight: bold;
                }
            </style>

    </main><!-- End #main -->
    <!-- END PAGE CONTENT WRAPPER -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<!--<script src="https://cdn.jsdelivr.net/jquery.validation/1.19.5/jquery.validate.min.js"></script>-->
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.1/umd/popper.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.6.0/js/bootstrap.min.js"></script>


<script>
    var dtabel;
    var vendor;
     var category;
      var status;
    var from_date;
    var to_date;
    
    var ispage;
    var url = '<?php echo base_url();?>';
    $(document).ready(function () {
        dtabel = $('#categories').DataTable({
            
           // "searching": false, "paging": false, "info": false
            
            "processing": true,
            "serverSide": true,
            "bStateSave": true,
            "language": {
            "emptyTable": "No Records Found!",
        },
        dom: '<"html5buttons" B>lTgtp',
        buttons: [],
        "aLengthMenu": [10, 20, 50, 100],
        "destroy": true,
        "ajax": {
            "url": "<?php echo base_url('register/all_expenses_info'); ?>",
            "type":"POST",
            beforeSend: function() {
              $("#wait").css("display", "block");
            },
            "data":function (d){
               d.vendor = vendor;
               d.category = category;
               d.status = status;
                d.from_date = from_date;
                d.to_date = to_date;
               //// d.search_is_1 = search_is_1;
            },
            "dataSrc": function ( jsondata ) {
                $("#wait").css("display", "none");
                return jsondata['data'];
            }
        },
        "columns": [
             { "title": " Expense no", "name":"sno", "orderable": false, "data":"expense_no", "width":"0%" },
            { "title": "Invoice no", "name":"category","orderable": false, "data":"invoice_no", "width":"0%" },
            { "title": "Date of expense", "name":"category","orderable": false, "data":"date_of_expense", "width":"0%" },
            { "title": "Amount Spent", "name":"category","orderable": false, "data":"amount_spent", "width":"0%" },
            { "title": "Status", "name":"category","orderable": false, "data":"expense_status", "width":"0%" },
           // { "title": "Purchased Date", "name":"category","orderable": false, "data":"purchased_date", "width":"0%" },
            
             
        ],
        "fnCreatedRow": function(nRow, aData, iDataIndex) 
        {
        //     if(aData['item_name']){
        //          url = "<?= base_url()?>edit-item/"+btoa(aData['id']);
        //         var name = '<a href='+url+'><strong>'+aData['item_name']+'</strong> </a>';
        //     }
        //     $(nRow).find('td:eq(0)').html(name);
            
        //     if(aData['user_status'] == '1'){
        //      var status = '<div class="form-check form-switch"><input checked class="form-check-input" type="checkbox" role="switch" id="flexSwitchCheckDefault" onclick="user_status('+aData['id']+','+aData['user_status']+')"><label class="form-check-label" for="flexSwitchCheckDefault">Active</label></div> <a href="#" class="" data-bs-toggle="dropdown"><img src="./assets/img/dots.png" style="width: 25px; padding: 5px; border: 1px solid rgba(0, 0, 0, 0.4); border-radius: 50px; background-color: #012970;" alt=""></a> <ul class="dropdown-menu dropdown-menu-end dropdown-menu-arrow"> <li><a class="dropdown-item" href="#">View/Add Documents</a>    </li>  <li><a class="dropdown-item" href="#">Student Ledger</a></li>  <li><a class="dropdown-item" href="#">ID Card</a></li> <li><a class="dropdown-item" href="#">QR Code</a></li> <li><a class="dropdown-item" href="#">Student Fee Structure</a></li></ul></div>';
        //   }else {
        //         var status = '<div class="form-check form-switch"><input class="form-check-input" type="checkbox" role="switch" id="flexSwitchCheckDefault" onclick="user_status('+aData['id']+','+aData['user_status']+')"><label class="form-check-label" for="flexSwitchCheckDefault">Inactive</label></div><div class="filter">  <a href="#" class="" data-bs-toggle="dropdown"><img src="./assets/img/dots.png" style="width: 25px; padding: 5px; border: 1px solid rgba(0, 0, 0, 0.4); border-radius: 50px; background-color: #012970;" alt=""></a> <ul class="dropdown-menu dropdown-menu-end dropdown-menu-arrow"> <li><a class="dropdown-item" href="#">View/Add Documents</a>    </li>  <li><a class="dropdown-item" href="#">Student Ledger</a></li>  <li><a class="dropdown-item" href="#">ID Card</a></li> <li><a class="dropdown-item" href="#">QR Code</a></li> <li><a class="dropdown-item" href="#">Student Fee Structure</a></li></ul></div>';
        //   }
        //   $(nRow).find('td:eq(7)').html(status);
           
// var date = aData['booking_date']+'('+aData['time_start']+' - '+aData['time_end']+')';
//          $(nRow).find('td:eq(2)').html(date);
//  if(aData['status'] == '1'){
//           var action ='<div class="filter">  <a href="#" class=" badge rounded-pill bg-primary fs-6 text-white py-2"    alt="" > <i class="bi bi-person-check "></i> &nbsp; Access Rights</a> </div>  <div class="filter pt-2"> <a href="#" onclick="user_status('+aData['id']+','+aData['status']+')" class=" badge rounded-pill bg-success fs-6 text-white py-2"  alt="" > <i class="bi bi-ban "></i> &nbsp; Deactivate</a>  </div>';
//  }else{                                      
//          var action ='<div class="filter">  <a href="#" class=" badge rounded-pill bg-primary fs-6 text-white py-2"   alt="" > <i class="bi bi-person-check "></i> &nbsp; Access Rights</a>  </div>  <div class="filter pt-2">    <a href="#" onclick="user_status('+aData['id']+','+aData['status']+')" class=" badge rounded-pill bg-danger fs-6 text-white py-2"  alt="" > <i class="bi bi-ban "></i> &nbsp; Activate</a>    </div>';
//  }
//           $(nRow).find('td:eq(5)').html(action);
         
        
        },
        "fnDrawCallback": function( oSettings ) {            
          //  var info = this.fnPagingInfo().iPage;
            var info = this.api().page.info();
            $("#atpagination").val(info+1);
            $("td:empty").html("&nbsp;");
        },
    });
    $("#search_user").click(function(){
        if($("#item_name").val()!=""){
          //  $("#search_on_1").css('background', '#ffffff');
            setallvalues();
            dtabel.draw();
        }else{
         $("#item_name").css('background', '#ffb3b3');
         $("#item_name").focus();
       alert('Please select any one filter to get data');
                     return false;
        }
    });
});
function setallvalues(){
    vendor = $("#vendor").val();
    category = $("#category").val();
    status = $("#status").val();
    from_date = $("#from_date").val();
    to_date = $("#to_date").val();
    var table = $('#categories').DataTable();
    var info = table.page.info();
    $("#atpagination").val((info.page+1));
    if(from_date!="" && to_date != ""){
        $("#searchreset").show();            
    }
    searchAstr = '';
}

function getpagenumber()
{
    return $("#atpagination").val() / $("#paginationlength").val();
}

  function user_status(id,status){
      
//	alert(id);
	$.ajax({
		'type' 		: 'post',
		'url'  		: '<?php echo base_url('register/update_staff_status/')?>',
		'data'   	: {id,status},
		'success'	: function(data){
		    const res = JSON.parse(data);
		    if(res.status){
		        showToast('Success', res.message, 'success');
		        $('#categories').DataTable().ajax.reload(null, false); // false prevents resetting the pagination
		    }else{
		        showToast('Error', res.message, 'error');
		    }
		    
		   // alert(data);
	//		window.location.reload();
		// $( "#categories" ).load();
	//	 $("#categories").ajax.reload();
			
		}		
	});
	
	//window.location.href();
	
}
</script>
