<!--<link href="https://cdn.datatables.net/2.1.8/css/dataTables.dataTables.min.css" rel="stylesheet">-->
<main id="main" class="main">
        <div class="messagelisting py-3 px-4">
            <div class="pagetitle m-0">
                <h1> Staff Details</h1>
                <nav>
                    <ol class="breadcrumb m-0">
                        <li class="breadcrumb-item"><a href="index.html">Home</a></li>
                        <li class="breadcrumb-item">Staff </li>
                        <li class="breadcrumb-item text-dark ">Edit Staff</li>
                    </ol>
                </nav>
            </div>

            <div class="dropdown">
               <button class="dropbtn"><span class="text-dark">Today </span> <?=date('D, d M')?></button>
            </div>
        </div>

        <section class="section">
            <div class="row justify-content-center align-items-center">
                <div class="col-lg-12">
                    <div class="col-lg-12">
                    <form action="">
                        <div class="card px-3 py-3">
                             <div class="d-flex justify-content-between">
                                <h5 class="px-3 pt-3"> Edit Staff</h5>
                            <div class="col-md-2 pt-2 d-flex justify-content-center align-items-center gap-3">
                                <div class="filter">
                                    <a href="#" class="btn btn-danger  text-white"
                                        data-bs-toggle="dropdown">Export Excel</a>
                                    <ul class="dropdown-menu dropdown-menu-end dropdown-menu-arrow">
                                        <li><a class="dropdown-item" href="#">Download Staff List</a></li>
                                        <li><a class="dropdown-item" href="#">Download ID Cards</a></li>
                                    </ul>
                                </div>
                                <button class="btn btn-danger"> <i class="bi bi-qr-code"></i></button>

                               </div>
                            </div>
                            <div class="card-body">
                                <div class="row g-3 needs-validation" novalidate="">
                                     <div class="col-md-8">
                                     <label for="" class="form-label">Staff</label>
                                        <input type="text" class="form-control" placeholder="Name"  name="search_text_1" id="search_text_1">
                                    </div>
                                  
                                   
                                    <div class="col-md-2 pt-2">
                                        <br>
                                        <input type="checkbox" class="form-check-label" name="search_on_1" id="search_on_1" value="1">
                                        <label for="validationCustom02" class=" form-label">Inactive Staff</label>
                                        <div class="valid-feedback">
                                            Looks good!
                                        </div>
                                    </div>
                                    <div class="col-md-2 pt-1">
                                        <label for="validationCustom02" class="form-label"> <span
                                                class="text-danger"></span></label>
                                        <button class="btn btn-danger mt-4" id="search_user" type="button"> <i class="bi bi-crosshair"></i> &nbsp;Search Staff</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                     </form>

                        <div class="card px-3 py-3">

                            <div class="card-body">


                                <table id="categories">

                                </table>

                            </div>
                        </div>
                </div>
                   
                </div>
            </div>
        </section>

         <style>
                .submit{
                   margin-right: 1rem;
                    float: right;
                }
                tr {

                    border-bottom: 1px solid rgba(0, 0, 0, 0.3);
                }

                td img{
                    width: 100px;
                }
                table {
                    width: 100%;
                    border-collapse: collapse;
                    margin: 20px 0;
                }

                th,
                td {
                    text-align: left;
                    line-height: 1.8;
                    /* border: 1px solid #ddd; */
                    padding: 8px;
                    font-size: 13px;
                }
                p,.fs-6{
                    font-size: 13px!important;
                }

                th {
                    background-color: #f4f4f4;
                    font-weight: bold;
                }
            </style>

    </main><!-- End #main -->
    <!-- END PAGE CONTENT WRAPPER -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<!--<script src="https://cdn.jsdelivr.net/jquery.validation/1.19.5/jquery.validate.min.js"></script>-->
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.1/umd/popper.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.6.0/js/bootstrap.min.js"></script>


    
            <!--<script src="<?= base_url()?>assets/vendor/libs/jquery/jquery.js"></script>-->
            <!--<script src="https://code.jquery.com/jquery-3.7.1.min.js" crossorigin="anonymous"></script>-->

<!--<script src="https://cdn.datatables.net/2.1.8/js/dataTables.min.js" type="text/javascript"></script>-->
<!--Load JQuery-->
<!--<script src="<?php echo base_url();?>assets/datatables/jquery.dataTables.min.js"></script>-->
<!--<script src="<?php echo base_url();?>assets/datatables/dataTables.bootstrap.min.js"></script>-->

<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.slim.min.js"></script>-->

<!--<script src="//cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>-->
<!--<script src="https://ajax.aspnetcdn.com/ajax/jquery.validate/1.11.1/jquery.validate.min.js"></script>-->



<script>
    var dtabel;
    var search_text_1;
    var search_on_1;
   // var search_at_1;
    
    var ispage;
    var url = '<?php echo base_url();?>';
    $(document).ready(function () {
        dtabel = $('#categories').DataTable({
            
           // "searching": false, "paging": false, "info": false
            
            "processing": true,
            "serverSide": true,
            "bStateSave": true,
            "language": {
            "emptyTable": "No Records Found!",
        },
        dom: '<"html5buttons" B>lTgtp',
        buttons: [],
        "aLengthMenu": [10, 20, 50, 100],
        "destroy": true,
        "ajax": {
            "url": "<?php echo base_url('register/all_staff_info'); ?>",
            "type":"POST",
            beforeSend: function() {
              $("#wait").css("display", "block");
            },
            "data":function (d){
                d.search_text_1 = search_text_1;
                d.search_on_1 = search_on_1;
             //   d.search_at_1 = search_at_1;
               //// d.search_is_1 = search_is_1;
            },
            "dataSrc": function ( jsondata ) {
                $("#wait").css("display", "none");
                return jsondata['data'];
            }
        },
        "columns": [
             { "title": "Image", "name":"sno", "orderable": false, "data":"employee_image", "width":"0%" },
            { "title": "Name", "name":"category","orderable": false, "data":"employee_name", "width":"0%" },
            { "title": "Class", "name":"category","orderable": false, "data":"class_name", "width":"0%" },
            { "title": "Mobile Number", "name":"category","orderable": false, "data":"employee_mobile", "width":"0%" },
            { "title": "Username", "name":"category","orderable": false, "data":"employee_email", "width":"0%" },
            { "title": "Actions", "name":"category","orderable": false, "data":"status", "width":"0%" },
            
             
        ],
        "fnCreatedRow": function(nRow, aData, iDataIndex) 
        {
            if(aData['employee_name']){
                 url = "<?= base_url()?>editstaff/"+btoa(aData['id']);
                var name = '<a href='+url+'><strong>'+aData['employee_name']+'</strong> </a>  <p> Id: '+aData['employee_id']+'</p>  <p>Designation :<span>'+aData['employee_designation']+'</span></p>   <p>Subjects  : <span>'+aData['employee_name']+'</span></p>   <p>Subject Teacher  : <span>'+aData['employee_class']+'</span></p><p>Group Admin  : <span>'+aData['employee_name']+'</span></p>';
            }
            $(nRow).find('td:eq(1)').html(name);
            if(aData['employee_image']){
                base_url = '<?php base_url()?>';
                var image = '<img src="'+base_url+''+aData['employee_image']+'"alt="">';
                $(nRow).find('td:eq(0)').html(image);
            }
            if(aData['user_status'] == '1'){
             var status = '<div class="form-check form-switch"><input checked class="form-check-input" type="checkbox" role="switch" id="flexSwitchCheckDefault" onclick="user_status('+aData['id']+','+aData['user_status']+')"><label class="form-check-label" for="flexSwitchCheckDefault">Active</label></div> <a href="#" class="" data-bs-toggle="dropdown"><img src="./assets/img/dots.png" style="width: 25px; padding: 5px; border: 1px solid rgba(0, 0, 0, 0.4); border-radius: 50px; background-color: #012970;" alt=""></a> <ul class="dropdown-menu dropdown-menu-end dropdown-menu-arrow"> <li><a class="dropdown-item" href="#">View/Add Documents</a>    </li>  <li><a class="dropdown-item" href="#">Student Ledger</a></li>  <li><a class="dropdown-item" href="#">ID Card</a></li> <li><a class="dropdown-item" href="#">QR Code</a></li> <li><a class="dropdown-item" href="#">Student Fee Structure</a></li></ul></div>';
           }else {
                var status = '<div class="form-check form-switch"><input class="form-check-input" type="checkbox" role="switch" id="flexSwitchCheckDefault" onclick="user_status('+aData['id']+','+aData['user_status']+')"><label class="form-check-label" for="flexSwitchCheckDefault">Inactive</label></div><div class="filter">  <a href="#" class="" data-bs-toggle="dropdown"><img src="./assets/img/dots.png" style="width: 25px; padding: 5px; border: 1px solid rgba(0, 0, 0, 0.4); border-radius: 50px; background-color: #012970;" alt=""></a> <ul class="dropdown-menu dropdown-menu-end dropdown-menu-arrow"> <li><a class="dropdown-item" href="#">View/Add Documents</a>    </li>  <li><a class="dropdown-item" href="#">Student Ledger</a></li>  <li><a class="dropdown-item" href="#">ID Card</a></li> <li><a class="dropdown-item" href="#">QR Code</a></li> <li><a class="dropdown-item" href="#">Student Fee Structure</a></li></ul></div>';
           }
           $(nRow).find('td:eq(7)').html(status);
           
// var date = aData['booking_date']+'('+aData['time_start']+' - '+aData['time_end']+')';
//          $(nRow).find('td:eq(2)').html(date);
 if(aData['status'] == '1'){
          var action ='<div class="filter">  <a href="#" class=" badge rounded-pill bg-primary fs-6 text-white py-2"    alt="" > <i class="bi bi-person-check "></i> &nbsp; Access Rights</a> </div>  <div class="filter pt-2"> <a href="#" onclick="user_status('+aData['id']+','+aData['status']+')" class=" badge rounded-pill bg-success fs-6 text-white py-2"  alt="" > <i class="bi bi-ban "></i> &nbsp; Deactivate</a>  </div>';
 }else{                                      
         var action ='<div class="filter">  <a href="#" class=" badge rounded-pill bg-primary fs-6 text-white py-2"   alt="" > <i class="bi bi-person-check "></i> &nbsp; Access Rights</a>  </div>  <div class="filter pt-2">    <a href="#" onclick="user_status('+aData['id']+','+aData['status']+')" class=" badge rounded-pill bg-danger fs-6 text-white py-2"  alt="" > <i class="bi bi-ban "></i> &nbsp; Activate</a>    </div>';
 }
          $(nRow).find('td:eq(5)').html(action);
         
        
        },
        "fnDrawCallback": function( oSettings ) {            
          //  var info = this.fnPagingInfo().iPage;
            var info = this.api().page.info();
            $("#atpagination").val(info+1);
            $("td:empty").html("&nbsp;");
        },
    });
    $("#search_user").click(function(){
        if($("#search_text_1").val()!="" || $("#search_on_1").val()!=""){
          //  $("#search_on_1").css('background', '#ffffff');
            setallvalues();
            dtabel.draw();
        }else{
         $("#search_text_1").css('background', '#ffb3b3');
         $("#search_text_1").focus();
       alert('Please select any one filter to get data');
                     return false;
        }
    });
});
function setallvalues(){
    search_text_1 = $("#search_text_1").val();
    search_on_1 = $("#search_on_1").val();
    search_at_1 = $("#search_at_1").val();
    var table = $('#categories').DataTable();
    var info = table.page.info();
    $("#atpagination").val((info.page+1));
    if(search_text_1!=""){
        $("#searchreset").show();            
    }
    searchAstr = '';
}

function getpagenumber()
{
    return $("#atpagination").val() / $("#paginationlength").val();
}

  function user_status(id,status){
      
//	alert(id);
	$.ajax({
		'type' 		: 'post',
		'url'  		: '<?php echo base_url('register/update_staff_status/')?>',
		'data'   	: {id,status},
		'success'	: function(data){
		    const res = JSON.parse(data);
		    if(res.status){
		        showToast('Success', res.message, 'success');
		        $('#categories').DataTable().ajax.reload(null, false); // false prevents resetting the pagination
		    }else{
		        showToast('Error', res.message, 'error');
		    }
		    
		   // alert(data);
	//		window.location.reload();
		// $( "#categories" ).load();
	//	 $("#categories").ajax.reload();
			
		}		
	});
	
	//window.location.href();
	
}
</script>
